Imports GameTrainerTemperate.clsSan11

Public Class Form1
    Dim San11 As New clsSan11

    Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Call CheckCLRversion()
        Call CreateBusyoTree()
    End Sub

    Private Sub CheckCLRversion()
        Dim clrVersionRuntime As String = Microsoft.VisualBasic.Left(System.Runtime.InteropServices.RuntimeEnvironment.GetSystemVersion(), 4)
        If Not clrVersionRuntime = "v2.0" Then
            MsgBox(".net Framework v2.0 ȏオKvł", MsgBoxStyle.Exclamation, "x")
            MyBase.Close()
        End If
    End Sub

    Private Sub CreateBusyoTree()
        Dim ReadAddress As Integer = San11.strSan11AddressData(0) + San11.intAddAddress

        For i As Integer = 0 To 3
            TreeBusyo.Nodes.Add(San11.strBusyoTreeTop(i))
        Next
        For i As Integer = 0 To 999
            Dim j As Integer
            Select Case i
                Case Is <= 699
                    j = 0
                Case Is <= 799
                    j = 1
                Case Is <= 849
                    j = 2
                Case Is <= 999
                    j = 3
            End Select
            TreeBusyo.Nodes(j).Nodes.Add(GetTreeData(i, ReadAddress))
            ReadAddress += San11.strSan11AddressData(1)
        Next
    End Sub

    Private Sub TreeBusyo_AfterSelect(ByVal sender As System.Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles TreeBusyo.AfterSelect
        For i As Integer = 0 To 3
            If e.Node.Text = San11.strBusyoTreeTop(i) Then
                ClearAllBox(Me)
                Exit Sub
            End If
        Next
        San11.WriteBusyoAddress = CInt(Microsoft.VisualBasic.Left(e.Node.Text(), 3))
        Call CreateBusyoData(San11.WriteBusyoAddress)
    End Sub

    Public Shared Function FindControl(ByVal hParent As Control, ByVal stName As String) As Control
        For Each hControl As Control In hParent.Controls
            If hControl.HasChildren = True Then
                Dim hFindControl As Control = FindControl(hControl, stName)
                If Not hFindControl Is Nothing Then
                    Return hFindControl
                End If
            End If
            If hControl.Name = stName Then
                Return hControl
            End If
        Next hControl
    End Function

    Public Sub ClearAllBox(ByVal hParent As Control)
        For Each hControl As Control In hParent.Controls
            If hControl.HasChildren = True Then
                ClearAllBox(hControl)
            End If
            If TypeOf hControl Is TextBoxBase Then
                hControl.Text = String.Empty
            End If
            If TypeOf hControl Is ListControl Then
                Dim hListControl As ListControl = DirectCast(hControl, ListControl)
                hListControl.SelectedIndex = -1
            End If
        Next hControl
    End Sub

    Public Sub ClearComboBox(ByVal hParent As Control)
        For Each hControl As Control In hParent.Controls
            If hControl.HasChildren = True Then
                ClearComboBox(hControl)
            End If
            If TypeOf hControl Is ListControl Then
                Dim hComboBox As ComboBox = DirectCast(hControl, ComboBox)
                hComboBox.Items.Clear()
            End If
        Next hControl
    End Sub

    Private Sub CreateBusyoData(ByVal e As Integer)
        For i As Integer = 0 To 2
            Dim hFindControl As Control = FindControl(Me, San11.strBaseBusyoTextData(i, 3) & i)
            hFindControl.Text = GetBusyoTextData(e, i)(0)
        Next
    End Sub

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim ReadAddress As Integer = San11.strSan11AddressData(0) + San11.strSan11AddressData(1) * San11.WriteBusyoAddress
        Dim NodeIndex As Integer = San11.WriteBusyoAddress

        For i As Integer = 0 To 2
            Dim hFindControl As Control = FindControl(Me, San11.strBaseBusyoTextData(i, 3) & i)
            San11.WriteDataList(i) = hFindControl.Text
        Next
        Call SetBusyoTextData(San11.WriteBusyoAddress, San11.WriteDataList)
    End Sub
End Class
