Public Class clsMemEdit
    ' Declare necessary API routines:
    Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" ( _
    ByVal lpClassName As String, ByVal lpWindowName As String) As IntPtr

    Public Declare Function GetWindowThreadProcessId Lib "user32" ( _
    ByVal hwnd As IntPtr, ByRef lpdwProcessId As Integer) As Integer

    Public Declare Function OpenProcess Lib "kernel32" ( _
    ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Boolean, ByVal dwProcessId As Integer) As IntPtr

    Public Declare Function CloseHandle Lib "kernel32" Alias "CloseHandle" ( _
    ByVal hObject As IntPtr) As Boolean

    Public Declare Function ReadProcessMemory Lib "kernel32" ( _
    ByVal hProcess As IntPtr, ByVal lpBaseAddress As Integer, ByRef lpBuffer As Long, ByVal nSize As Byte, _
    ByVal lpNumberOfBytesWritten As Integer) As Boolean

    Public Declare Function WriteProcessMemory Lib "kernel32" Alias "WriteProcessMemory" ( _
    ByVal hProcess As IntPtr, ByVal lpBaseAddress As Integer, ByRef lpBuffer As Long, ByVal nSize As Integer, _
    ByRef lpNumberOfBytesWritten As Integer) As Boolean

    Private Const PROCESS_ALL_ACCESS As Long = &H1F0FFF

    Shared Function GetWindowProcessID(ByVal Title As String) As IntPtr
        Dim hWnd As IntPtr = FindWindow(vbNullString, Title)
        Dim ProcessID As Integer
        Dim hProcess As IntPtr

        Call GetWindowThreadProcessId(hWnd, ProcessID)
        hProcess = OpenProcess(PROCESS_ALL_ACCESS, False, ProcessID)
        Return hProcess
    End Function

    Shared Function GetProcessMemory(ByVal hProc As IntPtr, ByVal Addr As Integer, ByVal ReadByte As Byte) As Long
        Dim bRet As Boolean
        Dim dwRead As Integer
        Dim res As Long

        bRet = ReadProcessMemory(hProc, Addr, res, ReadByte, dwRead)
        Return res
    End Function

    Shared Function GetProcessMemoryString(ByVal hProc As IntPtr, ByVal Addr As Integer, ByVal ReadByte As Byte) As String
        Dim bRet As Boolean
        Dim dwRead As Integer
        Dim res(ReadByte - 1) As Long
        Dim TextByte(ReadByte - 1) As Byte
        Dim TextBytes As String

        For i As Integer = 0 To ReadByte - 1
            bRet = ReadProcessMemory(hProc, Addr + i, res(i), 1, dwRead)
            If res(i) = 0 Then
                If i <> 0 Then ReadByte = CByte(i)
                If i = 0 Then
                    ReadByte = 0
                End If
                Exit For
            End If
            TextByte(i) = CByte(res(i))
        Next
        If ReadByte <> 0 Then
            TextBytes = System.Text.Encoding.GetEncoding("Shift_JIS").GetString(TextByte, 0, ReadByte)
        Else
            TextBytes = ""
        End If
        Return TextBytes
    End Function

    Shared Function SetProcessMemory(ByVal hProc As IntPtr, ByVal Addr As Integer, ByRef BufferData As Long, ByVal WriteByte As Byte) As Boolean
        Dim bRet As Boolean
        Dim dwWrite As Integer

        bRet = WriteProcessMemory(hProc, Addr, BufferData, WriteByte, dwWrite)
        Return bRet
    End Function

    Shared Function SetProcessMemoryString(ByVal hProc As IntPtr, ByVal Addr As Integer, ByRef BufferData As String, ByVal WriteByte As Byte) As Boolean
        Dim bRet As Boolean
        Const dwWrite As Integer = 0
        Dim TextByte() As Byte

        TextByte = System.Text.Encoding.GetEncoding("Shift_JIS").GetBytes(BufferData)
        ReDim Preserve TextByte(WriteByte)
        For i As Integer = 0 To WriteByte - 1
            bRet = WriteProcessMemory(hProc, Addr + i, CLng(TextByte(i)), 1, dwWrite)
        Next
        Return bRet
    End Function
End Class
